/[gentoo-x86]/eclass/kernel-2.eclass
Gentoo

Contents of /eclass/kernel-2.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.281 - (show annotations) (download)
Wed Mar 20 16:45:56 2013 UTC (17 months ago) by tomwij
Branch: MAIN
Changes since 1.280: +3 -3 lines
Use UID 0 instead of root to assign permissions to super user, bug #315807.

1 # Copyright 1999-2013 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.280 2013/03/20 07:55:54 tomwij Exp $
4
5 # Description: kernel.eclass rewrite for a clean base regarding the 2.6
6 # series of kernel with back-compatibility for 2.4
7 #
8 # Original author: John Mylchreest <johnm@gentoo.org>
9 # Maintainer: kernel-misc@gentoo.org
10 #
11 # Please direct your bugs to the current eclass maintainer :)
12
13 # added functionality:
14 # unipatch - a flexible, singular method to extract, add and remove patches.
15
16 # A Couple of env vars are available to effect usage of this eclass
17 # These are as follows:
18 #
19 # K_USEPV - When setting the EXTRAVERSION variable, it should
20 # add PV to the end.
21 # this is useful for thigns like wolk. IE:
22 # EXTRAVERSION would be something like : -wolk-4.19-r1
23 # K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be
24 # automatically set within the kernel Makefile
25 # K_NOUSENAME - if this is set then EXTRAVERSION will not include the
26 # first part of ${PN} in EXTRAVERSION
27 # K_NOUSEPR - if this is set then EXTRAVERSION will not include the
28 # anything based on ${PR}.
29 # K_PREPATCHED - if the patchset is prepatched (ie: mm-sources,
30 # ck-sources, ac-sources) it will use PR (ie: -r5) as
31 # the patchset version for
32 # and not use it as a true package revision
33 # K_EXTRAEINFO - this is a new-line seperated list of einfo displays in
34 # postinst and can be used to carry additional postinst
35 # messages
36 # K_EXTRAELOG - same as K_EXTRAEINFO except using elog instead of einfo
37 # K_EXTRAEWARN - same as K_EXTRAEINFO except using ewarn instead of einfo
38 # K_SYMLINK - if this is set, then forcably create symlink anyway
39 #
40 # K_DEFCONFIG - Allow specifying a different defconfig target.
41 # If length zero, defaults to "defconfig".
42 # K_WANT_GENPATCHES - Apply genpatches to kernel source. Provide any
43 # combination of "base" and "extras"
44 # K_GENPATCHES_VER - The version of the genpatches tarball(s) to apply.
45 # A value of "5" would apply genpatches-2.6.12-5 to
46 # my-sources-2.6.12.ebuild
47 # K_SECURITY_UNSUPPORTED- If set, this kernel is unsupported by Gentoo Security
48 # K_DEBLOB_AVAILABLE - A value of "0" will disable all of the optional deblob
49 # code. If empty, will be set to "1" if deblobbing is
50 # possible. Test ONLY for "1".
51 # K_PREDEBLOBBED - This kernel was already deblobbed elsewhere.
52 # If false, either optional deblobbing will be available
53 # or the license will note the inclusion of freedist
54 # code.
55 # K_LONGTERM - If set, the eclass will search for the kernel source
56 # in the long term directories on the upstream servers
57 # as the location has been changed by upstream
58 # H_SUPPORTEDARCH - this should be a space separated list of ARCH's which
59 # can be supported by the headers ebuild
60
61 # UNIPATCH_LIST - space delimetered list of patches to be applied to the
62 # kernel
63 # UNIPATCH_EXCLUDE - an addition var to support exlusion based completely
64 # on "<passedstring>*" and not "<passedno#>_*"
65 # - this should _NOT_ be used from the ebuild as this is
66 # reserved for end users passing excludes from the cli
67 # UNIPATCH_DOCS - space delimemeted list of docs to be installed to
68 # the doc dir
69 # UNIPATCH_STRICTORDER - if this is set places patches into directories of
70 # order, so they are applied in the order passed
71
72 inherit eutils toolchain-funcs versionator multilib
73 EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_test src_install pkg_preinst pkg_postinst pkg_postrm
74
75 # Added by Daniel Ostrow <dostrow@gentoo.org>
76 # This is an ugly hack to get around an issue with a 32-bit userland on ppc64.
77 # I will remove it when I come up with something more reasonable.
78 [[ ${PROFILE_ARCH} == "ppc64" ]] && CHOST="powerpc64-${CHOST#*-}"
79
80 export CTARGET=${CTARGET:-${CHOST}}
81 if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then
82 export CTARGET=${CATEGORY/cross-}
83 fi
84
85 HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/ ${HOMEPAGE}"
86 : ${LICENSE:="GPL-2"}
87
88 # This is the latest KV_PATCH of the deblob tool available from the
89 # libre-sources upstream. If you bump this, you MUST regenerate the Manifests
90 # for ALL kernel-2 consumer packages where deblob is available.
91 : ${DEBLOB_MAX_VERSION:=38}
92
93 # No need to run scanelf/strip on kernel sources/headers (bug #134453).
94 RESTRICT="binchecks strip"
95
96 # set LINUX_HOSTCFLAGS if not already set
97 : ${LINUX_HOSTCFLAGS:="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include"}
98
99 # debugging functions
100 #==============================================================
101 # this function exists only to help debug kernel-2.eclass
102 # if you are adding new functionality in, put a call to it
103 # at the start of src_unpack, or during SRC_URI/dep generation.
104 debug-print-kernel2-variables() {
105 for v in PVR CKV OKV KV KV_FULL KV_MAJOR KV_MINOR KV_PATCH RELEASETYPE \
106 RELEASE UNIPATCH_LIST_DEFAULT UNIPATCH_LIST_GENPATCHES \
107 UNIPATCH_LIST S KERNEL_URI K_WANT_GENPATCHES ; do
108 debug-print "${v}: ${!v}"
109 done
110 }
111
112 #Eclass functions only from here onwards ...
113 #==============================================================
114 handle_genpatches() {
115 local tarball
116 [[ -z ${K_WANT_GENPATCHES} || -z ${K_GENPATCHES_VER} ]] && return 1
117
118 debug-print "Inside handle_genpatches"
119 local OKV_ARRAY
120 IFS="." read -r -a OKV_ARRAY <<<"${OKV}"
121
122 # for > 3.0 kernels, handle genpatches tarball name
123 # genpatches for 3.0 and 3.0.1 might be named
124 # genpatches-3.0-1.base.tar.xz and genpatches-3.0-2.base.tar.xz
125 # respectively. Handle this.
126
127 for i in ${K_WANT_GENPATCHES} ; do
128 if [[ ${KV_MAJOR} -ge 3 ]]; then
129 if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
130 tarball="genpatches-${KV_MAJOR}.${KV_MINOR}-${K_GENPATCHES_VER}.${i}.tar.xz"
131 else
132 tarball="genpatches-${KV_MAJOR}.${KV_PATCH}-${K_GENPATCHES_VER}.${i}.tar.xz"
133 fi
134 else
135 tarball="genpatches-${OKV}-${K_GENPATCHES_VER}.${i}.tar.xz"
136 fi
137 debug-print "genpatches tarball: $tarball"
138 GENPATCHES_URI="${GENPATCHES_URI} mirror://gentoo/${tarball}"
139 UNIPATCH_LIST_GENPATCHES="${UNIPATCH_LIST_GENPATCHES} ${DISTDIR}/${tarball}"
140 done
141 }
142
143 detect_version() {
144 # this function will detect and set
145 # - OKV: Original Kernel Version (2.6.0/2.6.0-test11)
146 # - KV: Kernel Version (2.6.0-gentoo/2.6.0-test11-gentoo-r1)
147 # - EXTRAVERSION: The additional version appended to OKV (-gentoo/-gentoo-r1)
148
149 # We've already run, so nothing to do here.
150 [[ -n ${KV_FULL} ]] && return 0
151
152 # CKV is used as a comparison kernel version, which is used when
153 # PV doesnt reflect the genuine kernel version.
154 # this gets set to the portage style versioning. ie:
155 # CKV=2.6.11_rc4
156 CKV=${CKV:-${PV}}
157 OKV=${OKV:-${CKV}}
158 OKV=${OKV/_beta/-test}
159 OKV=${OKV/_rc/-rc}
160 OKV=${OKV/-r*}
161 OKV=${OKV/_p*}
162
163 KV_MAJOR=$(get_version_component_range 1 ${OKV})
164 # handle if OKV is X.Y or X.Y.Z (e.g. 3.0 or 3.0.1)
165 local OKV_ARRAY
166 IFS="." read -r -a OKV_ARRAY <<<"${OKV}"
167
168 # if KV_MAJOR >= 3, then we have no more KV_MINOR
169 #if [[ ${KV_MAJOR} -lt 3 ]]; then
170 if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
171 KV_MINOR=$(get_version_component_range 2 ${OKV})
172 KV_PATCH=$(get_version_component_range 3 ${OKV})
173 if [[ ${KV_MAJOR}${KV_MINOR}${KV_PATCH} -ge 269 ]]; then
174 KV_EXTRA=$(get_version_component_range 4- ${OKV})
175 KV_EXTRA=${KV_EXTRA/[-_]*}
176 else
177 KV_PATCH=$(get_version_component_range 3- ${OKV})
178 fi
179 else
180 KV_PATCH=$(get_version_component_range 2 ${OKV})
181 KV_EXTRA=$(get_version_component_range 3- ${OKV})
182 KV_EXTRA=${KV_EXTRA/[-_]*}
183 fi
184
185 debug-print "KV_EXTRA is ${KV_EXTRA}"
186
187 KV_PATCH=${KV_PATCH/[-_]*}
188
189 local v n=0 missing
190 #if [[ ${KV_MAJOR} -lt 3 ]]; then
191 if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
192 for v in CKV OKV KV_{MAJOR,MINOR,PATCH} ; do
193 [[ -z ${!v} ]] && n=1 && missing="${missing}${v} ";
194 done
195 else
196 for v in CKV OKV KV_{MAJOR,PATCH} ; do
197 [[ -z ${!v} ]] && n=1 && missing="${missing}${v} ";
198 done
199 fi
200
201 [[ $n -eq 1 ]] && \
202 eerror "Missing variables: ${missing}" && \
203 die "Failed to extract kernel version (try explicit CKV in ebuild)!"
204 unset v n missing
205
206 # if [[ ${KV_MAJOR} -ge 3 ]]; then
207 if [[ ${#OKV_ARRAY[@]} -lt 3 ]]; then
208 KV_PATCH_ARR=(${KV_PATCH//\./ })
209
210 # at this point 031412, Linus is putting all 3.x kernels in a
211 # 3.x directory, may need to revisit when 4.x is released
212 KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.x"
213
214 [[ -n "${K_LONGTERM}" ]] &&
215 KERNEL_BASE_URI="${KERNEL_BASE_URI}/longterm/v${KV_MAJOR}.${KV_PATCH_ARR}"
216 else
217 #KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.0"
218 #KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}"
219 if [[ ${KV_MAJOR} -ge 3 ]]; then
220 KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.x"
221 else
222 KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}"
223 fi
224
225 [[ -n "${K_LONGTERM}" ]] &&
226 #KERNEL_BASE_URI="${KERNEL_BASE_URI}/longterm"
227 KERNEL_BASE_URI="${KERNEL_BASE_URI}/longterm/v${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
228 fi
229
230 debug-print "KERNEL_BASE_URI is ${KERNEL_BASE_URI}"
231
232 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
233 # handle non genpatch using sources correctly
234 if [[ -z ${K_WANT_GENPATCHES} && -z ${K_GENPATCHES_VER} && ${KV_PATCH} -gt 0 ]]; then
235 KERNEL_URI="${KERNEL_BASE_URI}/patch-${OKV}.xz"
236 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.xz"
237 fi
238 KERNEL_URI="${KERNEL_URI} ${KERNEL_BASE_URI}/linux-${KV_MAJOR}.${KV_MINOR}.tar.xz"
239 else
240 KERNEL_URI="${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
241 fi
242
243 RELEASE=${CKV/${OKV}}
244 RELEASE=${RELEASE/_beta}
245 RELEASE=${RELEASE/_rc/-rc}
246 RELEASE=${RELEASE/_pre/-pre}
247 # We cannot trivally call kernel_is here, because it calls us to detect the
248 # version
249 #kernel_is ge 2 6 && RELEASE=${RELEASE/-pre/-git}
250 [ $(($KV_MAJOR * 1000 + ${KV_MINOR:-0})) -ge 2006 ] && RELEASE=${RELEASE/-pre/-git}
251 RELEASETYPE=${RELEASE//[0-9]}
252
253 # Now we know that RELEASE is the -rc/-git
254 # and RELEASETYPE is the same but with its numerics stripped
255 # we can work on better sorting EXTRAVERSION.
256 # first of all, we add the release
257 EXTRAVERSION="${RELEASE}"
258 debug-print "0 EXTRAVERSION:${EXTRAVERSION}"
259 [[ -n ${KV_EXTRA} ]] && [[ ${KV_MAJOR} -lt 3 ]] && EXTRAVERSION=".${KV_EXTRA}${EXTRAVERSION}"
260
261 debug-print "1 EXTRAVERSION:${EXTRAVERSION}"
262 if [[ -n "${K_NOUSEPR}" ]]; then
263 # Don't add anything based on PR to EXTRAVERSION
264 debug-print "1.0 EXTRAVERSION:${EXTRAVERSION}"
265 elif [[ -n ${K_PREPATCHED} ]]; then
266 debug-print "1.1 EXTRAVERSION:${EXTRAVERSION}"
267 EXTRAVERSION="${EXTRAVERSION}-${PN/-*}${PR/r}"
268 elif [[ "${ETYPE}" = "sources" ]]; then
269 debug-print "1.2 EXTRAVERSION:${EXTRAVERSION}"
270 # For some sources we want to use the PV in the extra version
271 # This is because upstream releases with a completely different
272 # versioning scheme.
273 case ${PN/-*} in
274 wolk) K_USEPV=1;;
275 vserver) K_USEPV=1;;
276 esac
277
278 [[ -z "${K_NOUSENAME}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*}"
279 [[ -n "${K_USEPV}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PV//_/-}"
280 [[ -n "${PR//r0}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PR}"
281 fi
282 debug-print "2 EXTRAVERSION:${EXTRAVERSION}"
283
284 # The only messing around which should actually effect this is for KV_EXTRA
285 # since this has to limit OKV to MAJ.MIN.PAT and strip EXTRA off else
286 # KV_FULL evaluates to MAJ.MIN.PAT.EXT.EXT after EXTRAVERSION
287
288 if [[ -n ${KV_EXTRA} ]]; then
289 if [[ -n ${KV_MINOR} ]]; then
290 OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
291 else
292 OKV="${KV_MAJOR}.${KV_PATCH}"
293 fi
294 KERNEL_URI="${KERNEL_BASE_URI}/patch-${CKV}.xz
295 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
296 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.xz"
297 fi
298
299 # We need to set this using OKV, but we need to set it before we do any
300 # messing around with OKV based on RELEASETYPE
301 KV_FULL=${OKV}${EXTRAVERSION}
302
303 # we will set this for backwards compatibility.
304 S=${WORKDIR}/linux-${KV_FULL}
305 KV=${KV_FULL}
306
307 # -rc-git pulls can be achieved by specifying CKV
308 # for example:
309 # CKV="2.6.11_rc3_pre2"
310 # will pull:
311 # linux-2.6.10.tar.xz & patch-2.6.11-rc3.xz & patch-2.6.11-rc3-git2.xz
312
313 if [[ ${KV_MAJOR}${KV_MINOR} -eq 26 ]]; then
314
315 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
316 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
317 KERNEL_URI="${KERNEL_BASE_URI}/testing/patch-${CKV//_/-}.xz
318 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
319 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.xz"
320 fi
321
322 if [[ ${RELEASETYPE} == -git ]]; then
323 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${OKV}${RELEASE}.xz
324 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
325 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.xz"
326 fi
327
328 if [[ ${RELEASETYPE} == -rc-git ]]; then
329 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
330 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.xz
331 ${KERNEL_BASE_URI}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.xz
332 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
333
334 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.xz ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.xz"
335 fi
336 else
337 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
338 if [[ ${KV_MAJOR}${KV_PATCH} -eq 30 ]]; then
339 OKV="2.6.39"
340 else
341 KV_PATCH_ARR=(${KV_PATCH//\./ })
342 OKV="${KV_MAJOR}.$((${KV_PATCH_ARR} - 1))"
343 fi
344 KERNEL_URI="${KERNEL_BASE_URI}/testing/patch-${CKV//_/-}.xz
345 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
346 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.xz"
347 fi
348
349 if [[ ${RELEASETYPE} == -git ]]; then
350 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${OKV}${RELEASE}.xz
351 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
352 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.xz"
353 fi
354
355 if [[ ${RELEASETYPE} == -rc-git ]]; then
356 if [[ ${KV_MAJOR}${KV_PATCH} -eq 30 ]]; then
357 OKV="2.6.39"
358 else
359 KV_PATCH_ARR=(${KV_PATCH//\./ })
360 OKV="${KV_MAJOR}.$((${KV_PATCH_ARR} - 1))"
361 fi
362 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE}.xz
363 ${KERNEL_BASE_URI}/testing/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE/-git*}.xz
364 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
365
366 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE/-git*}.xz ${DISTDIR}/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE}.xz"
367 fi
368
369
370 fi
371
372
373 debug-print-kernel2-variables
374
375 handle_genpatches
376 }
377
378 # Note: duplicated in linux-info.eclass
379 kernel_is() {
380 # ALL of these should be set before we can safely continue this function.
381 # some of the sources have in the past had only one set.
382 local v n=0
383 for v in OKV KV_{MAJOR,MINOR,PATCH} ; do [[ -z ${!v} ]] && n=1 ; done
384 [[ $n -eq 1 ]] && detect_version
385 unset v n
386
387 # Now we can continue
388 local operator test value
389
390 case ${1#-} in
391 lt) operator="-lt"; shift;;
392 gt) operator="-gt"; shift;;
393 le) operator="-le"; shift;;
394 ge) operator="-ge"; shift;;
395 eq) operator="-eq"; shift;;
396 *) operator="-eq";;
397 esac
398 [[ $# -gt 3 ]] && die "Error in kernel-2_kernel_is(): too many parameters"
399
400 : $(( test = (KV_MAJOR << 16) + (KV_MINOR << 8) + KV_PATCH ))
401 : $(( value = (${1:-${KV_MAJOR}} << 16) + (${2:-${KV_MINOR}} << 8) + ${3:-${KV_PATCH}} ))
402 [ ${test} ${operator} ${value} ]
403 }
404
405 kernel_is_2_4() {
406 kernel_is 2 4
407 }
408
409 kernel_is_2_6() {
410 kernel_is 2 6 || kernel_is 2 5
411 }
412
413 # Capture the sources type and set DEPENDs
414 if [[ ${ETYPE} == sources ]]; then
415 DEPEND="!build? ( sys-apps/sed
416 >=sys-devel/binutils-2.11.90.0.31 )"
417 RDEPEND="!build? ( >=sys-libs/ncurses-5.2
418 sys-devel/make
419 dev-lang/perl
420 sys-devel/bc )"
421 PDEPEND="!build? ( virtual/dev-manager )"
422
423 SLOT="${PVR}"
424 DESCRIPTION="Sources for the ${KV_MAJOR}.${KV_MINOR:-$KV_PATCH} linux kernel"
425 IUSE="symlink build"
426
427 # Bug #266157, deblob for libre support
428 if [[ -z ${K_PREDEBLOBBED} ]] ; then
429 # Bug #359865, force a call to detect_version if needed
430 kernel_is ge 2 6 27 && \
431 [[ -z "${K_DEBLOB_AVAILABLE}" ]] && \
432 kernel_is le 2 6 ${DEBLOB_MAX_VERSION} && \
433 K_DEBLOB_AVAILABLE=1
434 if [[ ${K_DEBLOB_AVAILABLE} == "1" ]] ; then
435 IUSE="${IUSE} deblob"
436 # Reflect that kernels contain firmware blobs unless otherwise
437 # stripped
438 LICENSE="${LICENSE} !deblob? ( freedist )"
439
440 if [[ -n KV_MINOR ]]; then
441 DEBLOB_PV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
442 else
443 DEBLOB_PV="${KV_MAJOR}.${KV_PATCH}"
444 fi
445
446 if [[ ${KV_MAJOR} -ge 3 ]]; then
447 DEBLOB_PV="${KV_MAJOR}.${KV_MINOR}"
448 fi
449
450 DEBLOB_A="deblob-${DEBLOB_PV}"
451 DEBLOB_CHECK_A="deblob-check-${DEBLOB_PV}"
452 DEBLOB_HOMEPAGE="http://www.fsfla.org/svnwiki/selibre/linux-libre/"
453 DEBLOB_URI_PATH="download/releases/LATEST-${DEBLOB_PV}.N"
454 if ! has "${EAPI:-0}" 0 1 ; then
455 DEBLOB_CHECK_URI="${DEBLOB_HOMEPAGE}/${DEBLOB_URI_PATH}/deblob-check -> ${DEBLOB_CHECK_A}"
456 else
457 DEBLOB_CHECK_URI="mirror://gentoo/${DEBLOB_CHECK_A}"
458 fi
459 DEBLOB_URI="${DEBLOB_HOMEPAGE}/${DEBLOB_URI_PATH}/${DEBLOB_A}"
460 HOMEPAGE="${HOMEPAGE} ${DEBLOB_HOMEPAGE}"
461
462 DEPEND+=" deblob? ( =dev-lang/python-2* )"
463 KERNEL_URI="${KERNEL_URI}
464 deblob? (
465 ${DEBLOB_URI}
466 ${DEBLOB_CHECK_URI}
467 )"
468 else
469 # We have no way to deblob older kernels, so just mark them as
470 # tainted with non-libre materials.
471 LICENSE="${LICENSE} freedist"
472 fi
473 fi
474
475 elif [[ ${ETYPE} == headers ]]; then
476 DESCRIPTION="Linux system headers"
477
478 # Since we should NOT honour KBUILD_OUTPUT in headers
479 # lets unset it here.
480 unset KBUILD_OUTPUT
481
482 SLOT="0"
483 else
484 eerror "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
485 die "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
486 fi
487
488 # Cross-compile support functions
489 #==============================================================
490 kernel_header_destdir() {
491 [[ ${CTARGET} == ${CHOST} ]] \
492 && echo /usr/include \
493 || echo /usr/${CTARGET}/usr/include
494 }
495
496 cross_pre_c_headers() {
497 use crosscompile_opts_headers-only && [[ ${CHOST} != ${CTARGET} ]]
498 }
499
500 env_setup_xmakeopts() {
501 # Kernel ARCH != portage ARCH
502 export KARCH=$(tc-arch-kernel)
503
504 # When cross-compiling, we need to set the ARCH/CROSS_COMPILE
505 # variables properly or bad things happen !
506 xmakeopts="ARCH=${KARCH}"
507 if [[ ${CTARGET} != ${CHOST} ]] && ! cross_pre_c_headers ; then
508 xmakeopts="${xmakeopts} CROSS_COMPILE=${CTARGET}-"
509 elif type -p ${CHOST}-ar > /dev/null ; then
510 xmakeopts="${xmakeopts} CROSS_COMPILE=${CHOST}-"
511 fi
512 export xmakeopts
513 }
514
515 # Unpack functions
516 #==============================================================
517 unpack_2_4() {
518 # this file is required for other things to build properly,
519 # so we autogenerate it
520 make -s mrproper ${xmakeopts} || die "make mrproper failed"
521 make -s symlinks ${xmakeopts} || die "make symlinks failed"
522 make -s include/linux/version.h ${xmakeopts} || die "make include/linux/version.h failed"
523 echo ">>> version.h compiled successfully."
524 }
525
526 unpack_2_6() {
527 # this file is required for other things to build properly, so we
528 # autogenerate it ... generate a .config to keep version.h build from
529 # spitting out an annoying warning
530 make -s mrproper ${xmakeopts} 2>/dev/null \
531 || die "make mrproper failed"
532
533 # quick fix for bug #132152 which triggers when it cannot include linux
534 # headers (ie, we have not installed it yet)
535 if ! make -s defconfig ${xmakeopts} &>/dev/null 2>&1 ; then
536 touch .config
537 eerror "make defconfig failed."
538 eerror "assuming you dont have any headers installed yet and continuing"
539 epause 5
540 fi
541
542 make -s include/linux/version.h ${xmakeopts} 2>/dev/null \
543 || die "make include/linux/version.h failed"
544 rm -f .config >/dev/null
545 }
546
547 universal_unpack() {
548 debug-print "Inside universal_unpack"
549
550 local OKV_ARRAY
551 IFS="." read -r -a OKV_ARRAY <<<"${OKV}"
552
553 cd "${WORKDIR}"
554 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
555 unpack linux-${KV_MAJOR}.${KV_MINOR}.tar.xz
556 else
557 unpack linux-${OKV}.tar.xz
558 fi
559
560 if [[ -d "linux" ]]; then
561 debug-print "Moving linux to linux-${KV_FULL}"
562 mv linux linux-${KV_FULL} \
563 || die "Unable to move source tree to ${KV_FULL}."
564 elif [[ "${OKV}" != "${KV_FULL}" ]]; then
565 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]] &&
566 [[ "${ETYPE}" = "sources" ]]; then
567 debug-print "moving linux-${KV_MAJOR}.${KV_MINOR} to linux-${KV_FULL} "
568 mv linux-${KV_MAJOR}.${KV_MINOR} linux-${KV_FULL} \
569 || die "Unable to move source tree to ${KV_FULL}."
570 else
571 debug-print "moving linux-${OKV} to linux-${KV_FULL} "
572 mv linux-${OKV} linux-${KV_FULL} \
573 || die "Unable to move source tree to ${KV_FULL}."
574 fi
575 elif [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
576 mv linux-${KV_MAJOR}.${KV_MINOR} linux-${KV_FULL} \
577 || die "Unable to move source tree to ${KV_FULL}."
578 fi
579 cd "${S}"
580
581 # remove all backup files
582 find . -iname "*~" -exec rm {} \; 2> /dev/null
583
584 }
585
586 unpack_set_extraversion() {
587 cd "${S}"
588 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile
589 cd "${OLDPWD}"
590 }
591
592 # Should be done after patches have been applied
593 # Otherwise patches that modify the same area of Makefile will fail
594 unpack_fix_install_path() {
595 cd "${S}"
596 sed -i -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile
597 }
598
599 # Compile Functions
600 #==============================================================
601 compile_headers() {
602 env_setup_xmakeopts
603
604 # if we couldnt obtain HOSTCFLAGS from the Makefile,
605 # then set it to something sane
606 local HOSTCFLAGS=$(getfilevar HOSTCFLAGS "${S}"/Makefile)
607 HOSTCFLAGS=${HOSTCFLAGS:--Wall -Wstrict-prototypes -O2 -fomit-frame-pointer}
608
609 if kernel_is 2 4; then
610 yes "" | make oldconfig ${xmakeopts}
611 echo ">>> make oldconfig complete"
612 make dep ${xmakeopts}
613 elif kernel_is 2 6; then
614 # 2.6.18 introduces headers_install which means we dont need any
615 # of this crap anymore :D
616 kernel_is ge 2 6 18 && return 0
617
618 # autoconf.h isnt generated unless it already exists. plus, we have
619 # no guarantee that any headers are installed on the system...
620 [[ -f ${ROOT}/usr/include/linux/autoconf.h ]] \
621 || touch include/linux/autoconf.h
622
623 # if K_DEFCONFIG isn't set, force to "defconfig"
624 # needed by mips
625 if [[ -z ${K_DEFCONFIG} ]]; then
626 if [[ $(KV_to_int ${KV}) -ge $(KV_to_int 2.6.16) ]]; then
627 case ${CTARGET} in
628 powerpc64*) K_DEFCONFIG="ppc64_defconfig";;
629 powerpc*) K_DEFCONFIG="pmac32_defconfig";;
630 *) K_DEFCONFIG="defconfig";;
631 esac
632 else
633 K_DEFCONFIG="defconfig"
634 fi
635 fi
636
637 # if there arent any installed headers, then there also isnt an asm
638 # symlink in /usr/include/, and make defconfig will fail, so we have
639 # to force an include path with $S.
640 HOSTCFLAGS="${HOSTCFLAGS} -I${S}/include/"
641 ln -sf asm-${KARCH} "${S}"/include/asm
642 cross_pre_c_headers && return 0
643
644 make ${K_DEFCONFIG} HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "defconfig failed (${K_DEFCONFIG})"
645 if compile_headers_tweak_config ; then
646 yes "" | make oldconfig HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "2nd oldconfig failed"
647 fi
648 make prepare HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
649 make prepare-all HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
650 fi
651 }
652
653 compile_headers_tweak_config() {
654 # some targets can be very very picky, so let's finesse the
655 # .config based upon any info we may have
656 case ${CTARGET} in
657 sh*)
658 sed -i '/CONFIG_CPU_SH/d' .config
659 echo "CONFIG_CPU_SH${CTARGET:2:1}=y" >> .config
660 return 0;;
661 esac
662
663 # no changes, so lets do nothing
664 return 1
665 }
666
667 # install functions
668 #==============================================================
669 install_universal() {
670 # Fix silly permissions in tarball
671 cd "${WORKDIR}"
672 chown -R 0:0 * >& /dev/null
673 chmod -R a+r-w+X,u+w *
674 cd ${OLDPWD}
675 }
676
677 install_headers() {
678 local ddir=$(kernel_header_destdir)
679
680 # 2.6.18 introduces headers_install which means we dont need any
681 # of this crap anymore :D
682 if kernel_is ge 2 6 18 ; then
683 env_setup_xmakeopts
684 emake headers_install INSTALL_HDR_PATH="${D}"/${ddir}/.. ${xmakeopts} || die
685
686 # let other packages install some of these headers
687 rm -rf "${D}"/${ddir}/sound #alsa-headers
688 rm -rf "${D}"/${ddir}/scsi #glibc/uclibc/etc...
689 return 0
690 fi
691
692 # Do not use "linux/*" as that can cause problems with very long
693 # $S values where the cmdline to cp is too long
694 pushd "${S}" >/dev/null
695 dodir ${ddir}/linux
696 cp -pPR "${S}"/include/linux "${D}"/${ddir}/ || die
697 rm -rf "${D}"/${ddir}/linux/modules
698
699 dodir ${ddir}/asm
700 cp -pPR "${S}"/include/asm/* "${D}"/${ddir}/asm
701
702 if kernel_is 2 6 ; then
703 dodir ${ddir}/asm-generic
704 cp -pPR "${S}"/include/asm-generic/* "${D}"/${ddir}/asm-generic
705 fi
706
707 # clean up
708 find "${D}" -name '*.orig' -exec rm -f {} \;
709
710 popd >/dev/null
711 }
712
713 install_sources() {
714 local file
715
716 cd "${S}"
717 dodir /usr/src
718 echo ">>> Copying sources ..."
719
720 file="$(find ${WORKDIR} -iname "docs" -type d)"
721 if [[ -n ${file} ]]; then
722 for file in $(find ${file} -type f); do
723 echo "${file//*docs\/}" >> "${S}"/patches.txt
724 echo "===================================================" >> "${S}"/patches.txt
725 cat ${file} >> "${S}"/patches.txt
726 echo "===================================================" >> "${S}"/patches.txt
727 echo "" >> "${S}"/patches.txt
728 done
729 fi
730
731 if [[ ! -f ${S}/patches.txt ]]; then
732 # patches.txt is empty so lets use our ChangeLog
733 [[ -f ${FILESDIR}/../ChangeLog ]] && \
734 echo "Please check the ebuild ChangeLog for more details." \
735 > "${S}"/patches.txt
736 fi
737
738 mv ${WORKDIR}/linux* "${D}"/usr/src
739 }
740
741 # pkg_preinst functions
742 #==============================================================
743 preinst_headers() {
744 local ddir=$(kernel_header_destdir)
745 [[ -L ${ddir}/linux ]] && rm ${ddir}/linux
746 [[ -L ${ddir}/asm ]] && rm ${ddir}/asm
747 }
748
749 # pkg_postinst functions
750 #==============================================================
751 postinst_sources() {
752 local MAKELINK=0
753
754 # if we have USE=symlink, then force K_SYMLINK=1
755 use symlink && K_SYMLINK=1
756
757 # if we're using a deblobbed kernel, it's not supported
758 [[ $K_DEBLOB_AVAILABLE == 1 ]] && \
759 use deblob && \
760 K_SECURITY_UNSUPPORTED=deblob
761
762 # if we are to forcably symlink, delete it if it already exists first.
763 if [[ ${K_SYMLINK} > 0 ]]; then
764 [[ -h ${ROOT}usr/src/linux ]] && rm ${ROOT}usr/src/linux
765 MAKELINK=1
766 fi
767
768 # if the link doesnt exist, lets create it
769 [[ ! -h ${ROOT}usr/src/linux ]] && MAKELINK=1
770
771 if [[ ${MAKELINK} == 1 ]]; then
772 cd "${ROOT}"usr/src
773 ln -sf linux-${KV_FULL} linux
774 cd ${OLDPWD}
775 fi
776
777 # Don't forget to make directory for sysfs
778 [[ ! -d ${ROOT}sys ]] && kernel_is 2 6 && mkdir ${ROOT}sys
779
780 echo
781 elog "If you are upgrading from a previous kernel, you may be interested"
782 elog "in the following document:"
783 elog " - General upgrade guide: http://www.gentoo.org/doc/en/kernel-upgrade.xml"
784 echo
785
786 # if K_EXTRAEINFO is set then lets display it now
787 if [[ -n ${K_EXTRAEINFO} ]]; then
788 echo ${K_EXTRAEINFO} | fmt |
789 while read -s ELINE; do einfo "${ELINE}"; done
790 fi
791
792 # if K_EXTRAELOG is set then lets display it now
793 if [[ -n ${K_EXTRAELOG} ]]; then
794 echo ${K_EXTRAELOG} | fmt |
795 while read -s ELINE; do elog "${ELINE}"; done
796 fi
797
798 # if K_EXTRAEWARN is set then lets display it now
799 if [[ -n ${K_EXTRAEWARN} ]]; then
800 echo ${K_EXTRAEWARN} | fmt |
801 while read -s ELINE; do ewarn "${ELINE}"; done
802 fi
803
804 # optionally display security unsupported message
805 # Start with why
806 if [[ ${K_SECURITY_UNSUPPORTED} = deblob ]]; then
807 ewarn "Deblobbed kernels are UNSUPPORTED by Gentoo Security."
808 elif [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
809 ewarn "${PN} is UNSUPPORTED by Gentoo Security."
810 fi
811 # And now the general message.
812 if [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
813 ewarn "This means that it is likely to be vulnerable to recent security issues."
814 ewarn "For specific information on why this kernel is unsupported, please read:"
815 ewarn "http://www.gentoo.org/proj/en/security/kernel.xml"
816 fi
817
818 # warn sparc users that they need to do cross-compiling with >= 2.6.25(bug #214765)
819 KV_MAJOR=$(get_version_component_range 1 ${OKV})
820 KV_MINOR=$(get_version_component_range 2 ${OKV})
821 KV_PATCH=$(get_version_component_range 3 ${OKV})
822 if [[ "$(tc-arch)" = "sparc" ]]; then
823 if [[ ${KV_MAJOR} -ge 3 || ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.24 ]]
824 then
825 echo
826 elog "NOTE: Since 2.6.25 the kernel Makefile has changed in a way that"
827 elog "you now need to do"
828 elog " make CROSS_COMPILE=sparc64-unknown-linux-gnu-"
829 elog "instead of just"
830 elog " make"
831 elog "to compile the kernel. For more information please browse to"
832 elog "https://bugs.gentoo.org/show_bug.cgi?id=214765"
833 echo
834 fi
835 fi
836 }
837
838 # pkg_setup functions
839 #==============================================================
840 setup_headers() {
841 [[ -z ${H_SUPPORTEDARCH} ]] && H_SUPPORTEDARCH=${PN/-*/}
842 for i in ${H_SUPPORTEDARCH}; do
843 [[ $(tc-arch) == "${i}" ]] && H_ACCEPT_ARCH="yes"
844 done
845
846 if [[ ${H_ACCEPT_ARCH} != "yes" ]]; then
847 echo
848 eerror "This version of ${PN} does not support $(tc-arch)."
849 eerror "Please merge the appropriate sources, in most cases"
850 eerror "(but not all) this will be called $(tc-arch)-headers."
851 die "Package unsupported for $(tc-arch)"
852 fi
853 }
854
855 # unipatch
856 #==============================================================
857 unipatch() {
858 local i x y z extention PIPE_CMD UNIPATCH_DROP KPATCH_DIR PATCH_DEPTH ELINE
859 local STRICT_COUNT PATCH_LEVEL myLC_ALL myLANG
860
861 # set to a standard locale to ensure sorts are ordered properly.
862 myLC_ALL="${LC_ALL}"
863 myLANG="${LANG}"
864 LC_ALL="C"
865 LANG=""
866
867 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/"
868 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR}
869
870 # We're gonna need it when doing patches with a predefined patchlevel
871 eshopts_push -s extglob
872
873 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers
874 # usage can be either via an env var or by params
875 # although due to the nature we pass this within this eclass
876 # it shall be by param only.
877 # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}"
878 UNIPATCH_LIST="${@}"
879
880 #unpack any passed tarballs
881 for i in ${UNIPATCH_LIST}; do
882 if echo ${i} | grep -qs -e "\.tar" -e "\.tbz" -e "\.tgz" ; then
883 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
884 unset z
885 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
886 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
887 do z="${z}0";
888 done
889 PATCH_ORDER="${z}${STRICT_COUNT}"
890
891 mkdir -p "${KPATCH_DIR}/${PATCH_ORDER}"
892 pushd "${KPATCH_DIR}/${PATCH_ORDER}" >/dev/null
893 unpack ${i##*/}
894 popd >/dev/null
895 else
896 pushd "${KPATCH_DIR}" >/dev/null
897 unpack ${i##*/}
898 popd >/dev/null
899 fi
900
901 [[ ${i} == *:* ]] && echo ">>> Strict patch levels not currently supported for tarballed patchsets"
902 else
903 extention=${i/*./}
904 extention=${extention/:*/}
905 PIPE_CMD=""
906 case ${extention} in
907 xz) PIPE_CMD="xz -dc";;
908 lzma) PIPE_CMD="lzma -dc";;
909 bz2) PIPE_CMD="bzip2 -dc";;
910 patch) PIPE_CMD="cat";;
911 diff) PIPE_CMD="cat";;
912 gz|Z|z) PIPE_CMD="gzip -dc";;
913 ZIP|zip) PIPE_CMD="unzip -p";;
914 *) UNIPATCH_DROP="${UNIPATCH_DROP} ${i/:*/}";;
915 esac
916
917 PATCH_LEVEL=${i/*([^:])?(:)}
918 i=${i/:*/}
919 x=${i/*\//}
920 x=${x/\.${extention}/}
921
922 if [ -n "${PIPE_CMD}" ]; then
923 if [ ! -r "${i}" ]; then
924 echo
925 eerror "FATAL: unable to locate:"
926 eerror "${i}"
927 eerror "for read-only. The file either has incorrect permissions"
928 eerror "or does not exist."
929 die Unable to locate ${i}
930 fi
931
932 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
933 unset z
934 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
935 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
936 do z="${z}0";
937 done
938 PATCH_ORDER="${z}${STRICT_COUNT}"
939
940 mkdir -p ${KPATCH_DIR}/${PATCH_ORDER}/
941 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${PATCH_ORDER}/${x}.patch${PATCH_LEVEL}) || die "uncompressing patch failed"
942 else
943 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${x}.patch${PATCH_LEVEL}) || die "uncompressing patch failed"
944 fi
945 fi
946 fi
947 done
948
949 #populate KPATCH_DIRS so we know where to look to remove the excludes
950 x=${KPATCH_DIR}
951 KPATCH_DIR=""
952 for i in $(find ${x} -type d | sort -n); do
953 KPATCH_DIR="${KPATCH_DIR} ${i}"
954 done
955
956 # do not apply fbcondecor patch to sparc/sparc64 as it breaks boot
957 # bug #272676
958 if [[ "$(tc-arch)" = "sparc" || "$(tc-arch)" = "sparc64" ]]; then
959 if [[ ${KV_MAJOR} -ge 3 || ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.28 ]]; then
960 UNIPATCH_DROP="${UNIPATCH_DROP} *_fbcondecor-0.9.6.patch"
961 echo
962 ewarn "fbcondecor currently prevents sparc/sparc64 from booting"
963 ewarn "for kernel versions >= 2.6.29. Removing fbcondecor patch."
964 ewarn "See https://bugs.gentoo.org/show_bug.cgi?id=272676 for details"
965 echo
966 fi
967 fi
968
969 #so now lets get rid of the patchno's we want to exclude
970 UNIPATCH_DROP="${UNIPATCH_EXCLUDE} ${UNIPATCH_DROP}"
971 for i in ${UNIPATCH_DROP}; do
972 ebegin "Excluding Patch #${i}"
973 for x in ${KPATCH_DIR}; do rm -f ${x}/${i}* 2>/dev/null; done
974 eend $?
975 done
976
977 # and now, finally, we patch it :)
978 for x in ${KPATCH_DIR}; do
979 for i in $(find ${x} -maxdepth 1 -iname "*.patch*" -or -iname "*.diff*" | sort -n); do
980 STDERR_T="${T}/${i/*\//}"
981 STDERR_T="${STDERR_T/.patch*/.err}"
982
983 [ -z ${i/*.patch*/} ] && PATCH_DEPTH=${i/*.patch/}
984 #[ -z ${i/*.diff*/} ] && PATCH_DEPTH=${i/*.diff/}
985
986 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi
987
988 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH}+)"
989 while [ ${PATCH_DEPTH} -lt 5 ]; do
990 echo "Attempting Dry-run:" >> ${STDERR_T}
991 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i}" >> ${STDERR_T}
992 echo "=======================================================" >> ${STDERR_T}
993 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then
994 echo "Attempting patch:" > ${STDERR_T}
995 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i}" >> ${STDERR_T}
996 echo "=======================================================" >> ${STDERR_T}
997 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then
998 eend 0
999 rm ${STDERR_T}
1000 break
1001 else
1002 eend 1
1003 eerror "Failed to apply patch ${i/*\//}"
1004 eerror "Please attach ${STDERR_T} to any bug you may post."
1005 eshopts_pop
1006 die "Failed to apply ${i/*\//}"
1007 fi
1008 else
1009 PATCH_DEPTH=$((${PATCH_DEPTH} + 1))
1010 fi
1011 done
1012 if [ ${PATCH_DEPTH} -eq 5 ]; then
1013 eend 1
1014 eerror "Please attach ${STDERR_T} to any bug you may post."
1015 eshopts_pop
1016 die "Unable to dry-run patch."
1017 fi
1018 done
1019 done
1020
1021 # This is a quick, and kind of nasty hack to deal with UNIPATCH_DOCS which
1022 # sit in KPATCH_DIR's. This is handled properly in the unipatch rewrite,
1023 # which is why I'm not taking too much time over this.
1024 local tmp
1025 for i in ${UNIPATCH_DOCS}; do
1026 tmp="${tmp} ${i//*\/}"
1027 cp -f ${i} "${T}"/
1028 done
1029 UNIPATCH_DOCS="${tmp}"
1030
1031 # clean up KPATCH_DIR's - fixes bug #53610
1032 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done
1033
1034 LC_ALL="${myLC_ALL}"
1035 LANG="${myLANG}"
1036 eshopts_pop
1037 }
1038
1039 # getfilevar accepts 2 vars as follows:
1040 # getfilevar <VARIABLE> <CONFIGFILE>
1041 # pulled from linux-info
1042
1043 getfilevar() {
1044 local workingdir basefname basedname xarch=$(tc-arch-kernel)
1045
1046 if [[ -z ${1} ]] && [[ ! -f ${2} ]]; then
1047 echo -e "\n"
1048 eerror "getfilevar requires 2 variables, with the second a valid file."
1049 eerror " getfilevar <VARIABLE> <CONFIGFILE>"
1050 else
1051 workingdir=${PWD}
1052 basefname=$(basename ${2})
1053 basedname=$(dirname ${2})
1054 unset ARCH
1055
1056 cd ${basedname}
1057 echo -e "include ${basefname}\ne:\n\t@echo \$(${1})" | \
1058 make ${BUILD_FIXES} -s -f - e 2>/dev/null
1059 cd ${workingdir}
1060
1061 ARCH=${xarch}
1062 fi
1063 }
1064
1065 detect_arch() {
1066 # This function sets ARCH_URI and ARCH_PATCH
1067 # with the neccessary info for the arch sepecific compatibility
1068 # patchsets.
1069
1070 local ALL_ARCH LOOP_ARCH COMPAT_URI i
1071
1072 # COMPAT_URI is the contents of ${ARCH}_URI
1073 # ARCH_URI is the URI for all the ${ARCH}_URI patches
1074 # ARCH_PATCH is ARCH_URI broken into files for UNIPATCH
1075
1076 ARCH_URI=""
1077 ARCH_PATCH=""
1078 ALL_ARCH="ALPHA AMD64 ARM HPPA IA64 M68K MIPS PPC PPC64 S390 SH SPARC X86"
1079
1080 for LOOP_ARCH in ${ALL_ARCH}; do
1081 COMPAT_URI="${LOOP_ARCH}_URI"
1082 COMPAT_URI="${!COMPAT_URI}"
1083
1084 [[ -n ${COMPAT_URI} ]] && \
1085 ARCH_URI="${ARCH_URI} $(echo ${LOOP_ARCH} | tr '[:upper:]' '[:lower:]')? ( ${COMPAT_URI} )"
1086
1087 if [[ ${LOOP_ARCH} == "$(echo $(tc-arch-kernel) | tr '[:lower:]' '[:upper:]')" ]]; then
1088 for i in ${COMPAT_URI}; do
1089 ARCH_PATCH="${ARCH_PATCH} ${DISTDIR}/${i/*\//}"
1090 done
1091 fi
1092 done
1093 }
1094
1095 headers___fix() {
1096 # Voodoo to partially fix broken upstream headers.
1097 # note: do not put inline/asm/volatile together (breaks "inline asm volatile")
1098 sed -i \
1099 -e '/^\#define.*_TYPES_H/{:loop n; bloop}' \
1100 -e 's:\<\([us]\(8\|16\|32\|64\)\)\>:__\1:g' \
1101 -e "s/\([[:space:]]\)inline\([[:space:](]\)/\1__inline__\2/g" \
1102 -e "s/\([[:space:]]\)asm\([[:space:](]\)/\1__asm__\2/g" \
1103 -e "s/\([[:space:]]\)volatile\([[:space:](]\)/\1__volatile__\2/g" \
1104 "$@"
1105 }
1106
1107 # common functions
1108 #==============================================================
1109 kernel-2_src_unpack() {
1110 universal_unpack
1111 debug-print "Doing unipatch"
1112
1113 [[ -n ${UNIPATCH_LIST} || -n ${UNIPATCH_LIST_DEFAULT} || -n ${UNIPATCH_LIST_GENPATCHES} ]] && \
1114 unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST_GENPATCHES} ${UNIPATCH_LIST}"
1115
1116 debug-print "Doing premake"
1117
1118 # allow ebuilds to massage the source tree after patching but before
1119 # we run misc `make` functions below
1120 [[ $(type -t kernel-2_hook_premake) == "function" ]] && kernel-2_hook_premake
1121
1122 debug-print "Doing epatch_user"
1123 epatch_user
1124
1125 debug-print "Doing unpack_set_extraversion"
1126
1127 [[ -z ${K_NOSETEXTRAVERSION} ]] && unpack_set_extraversion
1128 unpack_fix_install_path
1129
1130 # Setup xmakeopts and cd into sourcetree.
1131 env_setup_xmakeopts
1132 cd "${S}"
1133
1134 # We dont need a version.h for anything other than headers
1135 # at least, I should hope we dont. If this causes problems
1136 # take out the if/fi block and inform me please.
1137 # unpack_2_6 should now be 2.6.17 safe anyways
1138 if [[ ${ETYPE} == headers ]]; then
1139 kernel_is 2 4 && unpack_2_4
1140 kernel_is 2 6 && unpack_2_6
1141 fi
1142
1143 if [[ $K_DEBLOB_AVAILABLE == 1 ]] && use deblob ; then
1144 cp "${DISTDIR}/${DEBLOB_A}" "${T}" || die "cp ${DEBLOB_A} failed"
1145 cp "${DISTDIR}/${DEBLOB_CHECK_A}" "${T}/deblob-check" || die "cp ${DEBLOB_CHECK_A} failed"
1146 chmod +x "${T}/${DEBLOB_A}" "${T}/deblob-check" || die "chmod deblob scripts failed"
1147 fi
1148
1149 # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox
1150 # only do this for kernel < 2.6.27 since this file does not exist in later
1151 # kernels
1152 if [[ -n ${KV_MINOR} && ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} < 2.6.27 ]]
1153 then
1154 sed -i \
1155 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
1156 "${S}"/arch/ppc/Makefile
1157 else
1158 sed -i \
1159 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
1160 "${S}"/arch/powerpc/Makefile
1161 fi
1162 }
1163
1164 kernel-2_src_compile() {
1165 cd "${S}"
1166 [[ ${ETYPE} == headers ]] && compile_headers
1167
1168 if [[ $K_DEBLOB_AVAILABLE == 1 ]] && use deblob ; then
1169 echo ">>> Running deblob script ..."
1170 EPYTHON="python2" sh "${T}/${DEBLOB_A}" --force || die "Deblob script failed to run!!!"
1171 fi
1172 }
1173
1174 # if you leave it to the default src_test, it will run make to
1175 # find whether test/check targets are present; since "make test"
1176 # actually produces a few support files, they are installed even
1177 # though the package is binchecks-restricted.
1178 #
1179 # Avoid this altogether by making the function moot.
1180 kernel-2_src_test() { :; }
1181
1182 kernel-2_pkg_preinst() {
1183 [[ ${ETYPE} == headers ]] && preinst_headers
1184 }
1185
1186 kernel-2_src_install() {
1187 install_universal
1188 [[ ${ETYPE} == headers ]] && install_headers
1189 [[ ${ETYPE} == sources ]] && install_sources
1190 }
1191
1192 kernel-2_pkg_postinst() {
1193 [[ ${ETYPE} == sources ]] && postinst_sources
1194 }
1195
1196 kernel-2_pkg_setup() {
1197 if kernel_is 2 4; then
1198 if [[ $(gcc-major-version) -ge 4 ]] ; then
1199 echo
1200 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with linux-2.4!"
1201 ewarn "Either switch to another gcc-version (via gcc-config) or use a"
1202 ewarn "newer kernel that supports gcc-4."
1203 echo
1204 ewarn "Also be aware that bugreports about gcc-4 not working"
1205 ewarn "with linux-2.4 based ebuilds will be closed as INVALID!"
1206 echo
1207 epause 10
1208 fi
1209 fi
1210
1211 ABI="${KERNEL_ABI}"
1212 [[ ${ETYPE} == headers ]] && setup_headers
1213 [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..."
1214 }
1215
1216 kernel-2_pkg_postrm() {
1217 # This warning only makes sense for kernel sources.
1218 [[ ${ETYPE} == headers ]] && return 0
1219
1220 # If there isn't anything left behind, then don't complain.
1221 [[ -e ${ROOT}usr/src/linux-${KV_FULL} ]] || return 0
1222 echo
1223 ewarn "Note: Even though you have successfully unmerged "
1224 ewarn "your kernel package, directories in kernel source location: "
1225 ewarn "${ROOT}usr/src/linux-${KV_FULL}"
1226 ewarn "with modified files will remain behind. By design, package managers"
1227 ewarn "will not remove these modified files and the directories they reside in."
1228 echo
1229 }

  ViewVC Help
Powered by ViewVC 1.1.20